#include <windows.h>
#include <iostream>
using   namespace   std;  

#include "debugShell.h"

int main(int argc, char* argv[])
{
	/*
	 * Call debugShellInit() to start debugShell parser.
	 * After the execution of this sentence, You can call  all the functions and variables in console. 
	 * For example, in console enter showInfo( "hello word") or ivar=1(showInfo and ivar defined in the following)
	 */
	debugShellInit();
	for(;;)
	{
		Sleep(10000);
	}
	return 0;
}



////////////////////////////////////////////////
void showInfo( char *msg )
{
	cout << msg << endl;
	return;
}

/* Variety of basic types of variables */
bool  bvar;
char* pcvar     = "char";
wchar_t* pwcvar = L"wchar_t";
short svar;
int ivar;
int ivar2;
long lvar;
__int64 i64var;
unsigned short usvar;
unsigned int uivar;
unsigned __int64 ui64var;
double dvar;
float  fvar;

class VC2
{
public:
	int vc2var;
	int var;
	virtual int vf()
	{
		return 0;
	}
	virtual int vc2vf()
	{
		return 0;
	}
	int f()
	{
		return 0;
	}
	int vc2f()
	{
		return 0;
	}

};

class VC:virtual public VC2
{
public:
	int vcvar;
	int var;
	virtual int vf()
	{
		return 1;
	}
	virtual int vcvf()
	{
		return 1;
	}
	int f()
	{
		return 1;
	}
	int vcf()
	{
		return 1;
	}
};


class BC:virtual public VC
{
public:
	int bcvar;
	int var;
	virtual int vf()
	{
		return 2;
	}
	virtual int bcvf()
	{
		return 2;
	}
	int f()
	{
		return 2;
	}
	int bcf()
	{
		return 2;
	}
};

class BC2:virtual public VC
{
public:
	int bc2var;
	int var;
	virtual int vf()
	{
		return 3;
	}
	virtual int bc2vf()
	{
		return 3;
	}
	int f()
	{
		return 3;
	}
	int bc2f()
	{
		return 3;
	}
};

class TC:public BC,public BC2
{
public:
	int i;
	int l;
	int tcvar;
	int var;
	virtual int vf()
	{
		return 4;
	}
	virtual int tcvf()
	{
		return 4;
	}
	int f()
	{
		return 4;
	}
	int tcf()
	{
		return 4;
	}

	//////////////
	//Operator overloading
	bool operator==(const TC& a )
	{
		return false;
	}

	//Type conversion overloading
	operator int()
	{
		return 9;
	}

	//
	static int staticFun()
	{
		return 8;
	}
	int noStaticFun()
	{
		return i;
	}

	double __fastcall fastcallFun(int a, TC tcobj, VC2& vc2obj, double dValue, float b, int c)
	{
		double result = a + tcobj.tcvar + vc2obj.vc2var + dValue + b + c;
		return result;
	}

	float __stdcall stdcallFun(int a, TC tcobj, VC2& vc2obj, double dValue, float b, int c)
	{
		float result = a + tcobj.tcvar + vc2obj.vc2var + (float)dValue + b + c;
		return result;
	}

	__int64 __cdecl ccallFun(int a, TC tcobj, VC2& vc2obj, double dValue, float b, int c)
	{
		__int64 result = a + tcobj.tcvar + vc2obj.vc2var + (__int64)dValue + (__int64)b + c;
		return result;
	}

	long thiscallFun(int a, TC tcobj, VC2& vc2obj, double dValue, float b, int c)
	{
		long result = a + tcobj.tcvar + vc2obj.vc2var + (long)dValue + (long)b + c;
		return result;
	}
};

class TC2
{
public:

};

TC   obj;
BC   bcobj;
BC2  bc2obj;
VC   vcobj;
VC2  vc2obj;
TC2  tc2obj;
TC*  ptc;
TC2* ptc2;
BC*  pbc;
BC2* pbc2;
VC*  pvc;
VC2* pvc2;

TC** pptc;
BC2** ppbc2;


//Global operator overloading function
bool operator!=(const TC& a, const TC& b )
{
	return true;
}



//Parameters and return values are the class object
TC reObj( TC& a )
{
	a.tcvar   = 13;
	a.bcvar   = 14;
	a.vcvar   = 15;
	return a;
}

int testFun(TC a)
{
	a.tcvar = 16;
	return a.vcvar;
}


//Function Overloading
int testol(int i)
{
	return 2;
}
int testol(char* i)
{
	return 0;
}


//Various parameters, return values, and call type
double __fastcall fastcallFun(int a, TC tcobj, VC2& vc2obj, double dValue, float b, int c)
{
	double result = a + tcobj.tcvar + vc2obj.vc2var + dValue + b + c;
	return result;
}
float __stdcall stdcallFun(int a, TC tcobj, VC2& vc2obj, double dValue, float b, int c)
{
	float result = a + tcobj.tcvar + vc2obj.vc2var + (float)dValue + b + c;
	return result;
}
__int64 __cdecl ccallFun(int a, TC tcobj, VC2& vc2obj, double dValue, float b, int c)
{
	__int64 result = a + tcobj.tcvar + vc2obj.vc2var + (__int64)dValue + (__int64)b + c;
	return result;
}

//Variable parameters
int vaFun(int start,... ){
	int result = 0;
	va_list arg_ptr;
	int nArgValue = start;
	va_start(arg_ptr, start);  
	do{
		result +=  nArgValue;
		nArgValue = va_arg(arg_ptr, int);
	}while(nArgValue != -1);
	va_end(arg_ptr);
	return result;
}

///////////////////////////////////////////////////////////////////////////////
// The following function implementation can also be used as dsClient script //
///////////////////////////////////////////////////////////////////////////////

// Test interpretation "if", "if-else", "for", "do-while", "while" statement
void testDSClient()
{
	ivar = 1;
	if ( 0 || ivar )
	{
		showInfo("if : ok"); //If you see this message.It is OK
	}

	if ( !ivar ) //ivar value is 1, !ivar is false, so should not perform the following showInfo()
	{
		showInfo("if : fail");//If you see this message,test fail!
	}

	/* if-else */
	if ( 0 &&  ivar)
	{
		showInfo("if-else : fail");
	}
	else
	{
		showInfo("if-else : ok");
	}

	/* for */
	ivar = 0;
	for( ivar2 = 0; ivar2 < 2; ivar2++)
	{
		showInfo("in for");
		ivar++;
	}
	if ( (2 != ivar2) || ( 2 != ivar ))
	{
		showInfo("for fail");
	}
	else
	{
		showInfo("for ok");
	}

	//do-while
	ivar = 0;
	ivar2 = 0;
	do{
		ivar++;
		if ( 3 == ivar )
		{
			continue;
		}
		ivar2++;	
	}while( ivar < 5); 

	if ( ( 5 != ivar) || ( 4 != ivar2 ) )
	{
		showInfo("do-while fail");
		showInfo("continue fail");
	}
	else
	{
		showInfo("do-while ok");
		showInfo("continue ok");
	}

	//while
	ivar = 0;
	while( ivar < 5 )
	{
		if ( 2 == ivar )
		{
			break;////break. If the interpretation is correct, out of cycles, ivar value is 2
		}

		//
		for( ivar2 = 0; ivar2 < 5; ivar2++ )
		{
			if ( 3 == ivar2 )
			{
				break; //break in the multi-nested.If the interpretation is correct, out of cycles, ivar2 value is 3
			}
		}
		ivar++;
	};
	if ( (2 != ivar) || ( 3 != ivar2 ) )
	{
		showInfo("while fail");
		showInfo("break fail");
	}
	else
	{
		showInfo("while ok");
		showInfo("break ok");
	}

	//return
	showInfo("return ok");
	return ;

	showInfo("return fail");//If you see this message,test fail!	
}

void testFuncall()
{
	//Call the static function
	if ( 8 == TC::staticFun())
	{
		showInfo("static memberr ok");
	}
	else
	{
		showInfo("static memberr fail");
	}

	//Call non-static function
	obj.i = 4;
	if ( 4 == obj.noStaticFun() )
	{
		showInfo("non-static memberr ok");
	}
	else
	{
		showInfo("non-static memberr fail");
	}

	// Test the following situation:
	// 1.Parameters and return value is an object;
	// 2.Parameter has copy constructor function
	obj.i = testFun( reObj( obj));
	if ( (15 != obj.i) || ( 14 != obj.bcvar) || ( 16 == obj.tcvar ))
	{
		showInfo("fun and referencn fail");
	}
	else
	{
		showInfo("fun and referencn ok");
	}

	// Test the following situation:
	// 1.Function parameters mixed  variety types
	// 2.Variety types of return values
	// 3.Variety of call types
	obj.tcvar = 1;
	vc2obj.vc2var = 1;
	fvar   = stdcallFun( 1, obj, vc2obj, 1.0, 1.0, 1);
	dvar   = fastcallFun( 1, obj, vc2obj, 1.0, (float)1.0, 1);
	i64var = ccallFun( 1, obj, vc2obj, 1.0, (float)1.0, 1);
	ivar   = (int)obj.stdcallFun( 1, obj, vc2obj, 1.0, (float)1.0, 1);
	ivar2  = (int)obj.fastcallFun( 1, obj, vc2obj, 1.0, (float)1.0, 1);
	svar   = (short)obj.ccallFun( 1, obj, vc2obj, 1.0, (float)1.0, 1);
	lvar   = obj.thiscallFun( 1, obj, vc2obj, 1.0, (float)1.0, 1);
	if ( (6 == fvar) && (6 == dvar) && (6 == ivar) && (6 == ivar2)
		&& ( 6 == i64var) && ( 6 == svar ) && ( 6 == lvar ))
	{
		showInfo("fastcall & stdcall ok");
	}
	else
	{
		showInfo("fastcall & stdcall fail");
	}


	// Variable parameter
	if ( (6 == vaFun(1,2,3,-1)) && ( 7 == vaFun(4,3,-1) ) )
	{
		showInfo("variable argument ok");
	}
	else
	{
		showInfo("variable argument fail");
	}


	return;

}

// function overloading
void testOverload()
{
	// function overloading
	if( 2 != testol(3) )
	{
		showInfo("fun overload fail");
		return;
	}
	if ( 0 != testol("asdf") )
	{
		showInfo("fun overload fail");
		return;
	}
	showInfo("fun overload ok");

	return;
}

// namespace
void testNS()
{
	return;	
}

// 
void vailidDataAccess()
{
	ptc  = &obj;
	pbc  = (BC*)ptc;
	pbc2 = (BC2*)ptc;
	pvc  = (VC*)ptc;

	bool result = true;

	// Member variable
	result &= (obj.tcvar         == 10);
	result &= (ptc->var          == 11);
	result &= (ptc->BC::var      == 12);
	result &= (pbc->bcvar        == 13);
	result &= (pbc2->var         == 14);
	result &= (obj.BC2::bc2var   == 15);
	result &= (obj.BC::VC::var   == 16);
	result &= (pvc->vcvar        == 17);
	result &= (pbc->VC::VC2::var == 18);
	result &= (pbc->VC2::vc2var  == 19);

	if ( !result  )
	{
		showInfo("Member variable:fail");
	}
	else
	{
		showInfo("Member variable:ok");
	}
}
// class
void testClass()
{
	ptc  = &obj;
	pbc  = ptc;
	pbc2 = ptc;
	pvc  = ptc;


	// Access the data member
	obj.tcvar         = 10;
	ptc->BC::var      = 12;
	pbc->bcvar        = 13;
	pbc2->var         = 14;
	obj.BC2::bc2var   = 15;
	obj.BC::VC::var   = 16;
	pvc->vcvar        = 17;
	pbc->VC::VC2::var = 18;
	pbc->VC2::vc2var  = 19;
	ptc = (TC*)pbc2; //  Base class pointer convert to subclass pointer
	ptc->var          = 11;

	// Verify the above assignment statement 
	vailidDataAccess();
	

	// subclass convert to base class
	obj.BC2::var = 2;
	obj.BC2::VC::var = 3;
	bc2obj = obj;
	if( (2 != bc2obj.var) || ( 3 != bc2obj.VC::var)
		|| 3 != bc2obj.vf()) 
	{
		showInfo("subclass convert to base class:fail");
	}
	else
	{
		showInfo("subclass convert to base class:ok");
	}	


	// construct, copy construct


	// function overriding
	if ( ( 2 != pbc->f()) || ( 1 != pvc->f() ))
	{
		showInfo("overriding:fail");
	}
	else
	{
		showInfo("overriding:ok");
	}
}

// type conversion and operator overloading
void testTC()
{
	// operator overloading
	if ( obj == obj ) //Member function overloadingreturn value is always false
	{
		showInfo("operator overloading:fail");
	}
	else
	{
		showInfo("operator overloading:ok");
	}

	if ( obj != obj ) //Global overloading, return value is always true
	{
		showInfo("global operator overloading:ok");
	}
	else
	{
		showInfo("global operator overload:fail");
	}
	
	
	//	TC::operator int(){	return 9;}
	if ( 9 != (int)obj )
	{
		showInfo("type overloading:fail");
	}
	else
	{
		showInfo("type overloading:ok");
	}

}

bool vailidVirtual()
{
	if ( (obj.vcvar  != 21) || ( obj.vc2var != 22))
	{
		showInfo("Virtual base class conversion:fail");
		return false;
	}
	else
	{
		showInfo("Virtual base class conversion:ok");
		return true;
	}
	return false;
}


// Virtual inheritance and Virtual function
void testVirtual()
{
	// Convert virtual base class pointer
	ptc   = &obj;
	pvc   = (VC*)ptc;
	pbc   = (BC*)ptc;
	pbc2  = (BC2*)ptc;
	pvc2  = (VC2*)pbc2;

	pvc->vcvar = 21;
	pvc2->vc2var = 22;
	
	// verify the conversion
	if ( !vailidVirtual()) //
	{
		return; //
	}

	
	//Virtual function
	if ( (4 != ptc->vf()) || (4 != pbc->vf()) || (4 != pbc2->vf())
		|| (4 != pvc->vf()) || (4 != pvc2->vf()) || ( 2 != bcobj.vf()) || ( 1 != vcobj.vf() ))
	{
		showInfo("Virtual function:fail");
	}
	else
	{
		showInfo("Virtual function:ok");
	}
}

bool validSize( int intsize, int doublesize,int tcsize, int tcobjsize )
{
	if ( intsize != sizeof(int) || doublesize!=sizeof(double) || tcsize != sizeof(TC) || tcobjsize!= sizeof(obj) )
	{
		return false;
	}
	return true;
}

// Basic type data 
void testBasetype()
{
	// +-*/
	bvar = true;
	bvar &= ( 22 == ( 1 + 0x10 + 2*3 - (1+2) +4/2 ));

	//++,--
	ivar = 2;
	ivar2 = ivar++;
	bvar &= ( (2 == ivar2) && ( 3 == ivar ) );

	ivar  = 2;
	ivar2 = ++ivar;
	bvar &= ( (3 == ivar2) && ( 3 == ivar ));

	ivar = 2;
	ivar2 = ivar--;
	bvar &= ( (2 == ivar2) && ( 1 == ivar ) );

	ivar  = 2;
	ivar2 = --ivar;
	bvar &= ( (1 == ivar2) && ( 1 == ivar ));

	//a?b:c
	ivar = 1;
	bvar &= ( 1 == ivar ? 1 : 0 );
	bvar &= ( 0 == (!ivar) ? 1:0 );

	if ( bvar )
	{
		showInfo("Basic type:ok");
	}
	else
	{
		showInfo("Basic type:fail");
	}

	// sizeof	
	if ( validSize( sizeof(int), sizeof(double),sizeof(TC), sizeof(obj) ) )
	{
		showInfo("sizeof:ok");
	}
	else
	{
		showInfo("sizeof:fail");
	}


	//dumvar
	//dumpvar( *(testClass*)gpb );//Script can call this function, compile-time can not be called


	return;
}


class J
{
public:
	int vc2var;
	int var;
	virtual int vf()
	{
		return 0;
	}
	virtual int vc2vf()
	{
		return 0;
	}
	int f()
	{
		return 0;
	}
	int vc2f()
	{
		return 0;
	}

};

